/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */
import type {
  BaseContract,
  BigNumberish,
  BytesLike,
  FunctionFragment,
  Result,
  Interface,
  EventFragment,
  AddressLike,
  ContractRunner,
  ContractMethod,
  Listener,
} from "ethers";
import type {
  TypedContractEvent,
  TypedDeferredTopicFilter,
  TypedEventLog,
  TypedLogDescription,
  TypedListener,
  TypedContractMethod,
} from "../common";

export declare namespace Staking {
  export type StakeStruct = {
    id: BigNumberish;
    amount: BigNumberish;
    earned: BigNumberish;
    claimed: BigNumberish;
    userRewardPerTokenPaid: BigNumberish;
    owner: AddressLike;
    timestamp: BigNumberish;
    unstakedAtBlockNumber: BigNumberish;
    unstakedAtBlockTimestamp: BigNumberish;
  };

  export type StakeStructOutput = [
    id: bigint,
    amount: bigint,
    earned: bigint,
    claimed: bigint,
    userRewardPerTokenPaid: bigint,
    owner: string,
    timestamp: bigint,
    unstakedAtBlockNumber: bigint,
    unstakedAtBlockTimestamp: bigint
  ] & {
    id: bigint;
    amount: bigint;
    earned: bigint;
    claimed: bigint;
    userRewardPerTokenPaid: bigint;
    owner: string;
    timestamp: bigint;
    unstakedAtBlockNumber: bigint;
    unstakedAtBlockTimestamp: bigint;
  };
}

export interface StakingInterface extends Interface {
  getFunction(
    nameOrSignature:
      | "ACCURACY"
      | "MAX_RATE"
      | "MAX_REWARDS_DURATION"
      | "MAX_STAKE"
      | "MIN_REWARDS_DURATION"
      | "TREASURY_STAKE_AMOUNT"
      | "balanceOf"
      | "claim"
      | "cumulativeDistributedReward"
      | "cumulativeRewardPaid"
      | "currentPeriodUnusedRewardsSum"
      | "currentRewardPaid"
      | "disableErrorGuard"
      | "earned"
      | "errorGuardDisabled"
      | "errorGuardPullTokens"
      | "errorGuardRewardToken"
      | "errorGuardStakingToken"
      | "finish"
      | "finished"
      | "firstRewardPeriodStart"
      | "getHoldersLength"
      | "getHoldersSlice"
      | "getPotentialAPR"
      | "getTotalRewards"
      | "getUnusedRewards"
      | "getUserInactiveStakesLength"
      | "getUserInactiveStakesSlice"
      | "getUserStakeIdsLength"
      | "getUserStakesSlice"
      | "globalId"
      | "hasStakeId"
      | "init"
      | "lastTimeRewardApplicable"
      | "lastUpdateTime"
      | "notifyRewardAmount"
      | "notifyRewardAmountPrevious"
      | "numOfActiveStakes"
      | "owner"
      | "paused"
      | "periodFinish"
      | "periodStart"
      | "renounceOwnership"
      | "rewardPerToken"
      | "rewardPerTokenStored"
      | "rewardRate"
      | "rewardToken"
      | "rewardsDuration"
      | "rewardsRemaining"
      | "setPaused"
      | "setRewardsDuration"
      | "stake"
      | "stakes"
      | "stakingToken"
      | "totalSupply"
      | "transferOwnership"
      | "unusedRewardsExtracted"
      | "userBalances"
      | "userInactiveStakes"
      | "withdraw"
      | "withdrawOtherTokens"
  ): FunctionFragment;

  getEvent(
    nameOrSignatureOrTopic:
      | "ErrorGuardDisaabled"
      | "ErrorGuardPulledTokens"
      | "ErrorGuardUpdatedRewardToken"
      | "ErrorGuardUpdatedStakingToken"
      | "Finished"
      | "Initialized"
      | "OwnershipTransferred"
      | "Paused"
      | "RewardAdded"
      | "RewardPaid"
      | "RewardsDurationUpdated"
      | "Staked"
      | "Unpaused"
      | "Withdrawn"
      | "WithdrawnTokens"
  ): EventFragment;

  encodeFunctionData(functionFragment: "ACCURACY", values?: undefined): string;
  encodeFunctionData(functionFragment: "MAX_RATE", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "MAX_REWARDS_DURATION",
    values?: undefined
  ): string;
  encodeFunctionData(functionFragment: "MAX_STAKE", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "MIN_REWARDS_DURATION",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "TREASURY_STAKE_AMOUNT",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "balanceOf",
    values: [AddressLike]
  ): string;
  encodeFunctionData(functionFragment: "claim", values: [BigNumberish]): string;
  encodeFunctionData(
    functionFragment: "cumulativeDistributedReward",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "cumulativeRewardPaid",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "currentPeriodUnusedRewardsSum",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "currentRewardPaid",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "disableErrorGuard",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "earned",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "errorGuardDisabled",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "errorGuardPullTokens",
    values: [AddressLike, AddressLike, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "errorGuardRewardToken",
    values: [AddressLike]
  ): string;
  encodeFunctionData(
    functionFragment: "errorGuardStakingToken",
    values: [AddressLike]
  ): string;
  encodeFunctionData(functionFragment: "finish", values: [AddressLike]): string;
  encodeFunctionData(functionFragment: "finished", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "firstRewardPeriodStart",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "getHoldersLength",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "getHoldersSlice",
    values: [BigNumberish, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "getPotentialAPR",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "getTotalRewards",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "getUnusedRewards",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "getUserInactiveStakesLength",
    values: [AddressLike]
  ): string;
  encodeFunctionData(
    functionFragment: "getUserInactiveStakesSlice",
    values: [AddressLike, BigNumberish, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "getUserStakeIdsLength",
    values: [AddressLike]
  ): string;
  encodeFunctionData(
    functionFragment: "getUserStakesSlice",
    values: [AddressLike, BigNumberish, BigNumberish]
  ): string;
  encodeFunctionData(functionFragment: "globalId", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "hasStakeId",
    values: [AddressLike, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "init",
    values: [AddressLike, AddressLike, AddressLike]
  ): string;
  encodeFunctionData(
    functionFragment: "lastTimeRewardApplicable",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "lastUpdateTime",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "notifyRewardAmount",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "notifyRewardAmountPrevious",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "numOfActiveStakes",
    values?: undefined
  ): string;
  encodeFunctionData(functionFragment: "owner", values?: undefined): string;
  encodeFunctionData(functionFragment: "paused", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "periodFinish",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "periodStart",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "renounceOwnership",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "rewardPerToken",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "rewardPerTokenStored",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "rewardRate",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "rewardToken",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "rewardsDuration",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "rewardsRemaining",
    values?: undefined
  ): string;
  encodeFunctionData(functionFragment: "setPaused", values: [boolean]): string;
  encodeFunctionData(
    functionFragment: "setRewardsDuration",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(functionFragment: "stake", values: [BigNumberish]): string;
  encodeFunctionData(
    functionFragment: "stakes",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "stakingToken",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "totalSupply",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "transferOwnership",
    values: [AddressLike]
  ): string;
  encodeFunctionData(
    functionFragment: "unusedRewardsExtracted",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "userBalances",
    values: [AddressLike]
  ): string;
  encodeFunctionData(
    functionFragment: "userInactiveStakes",
    values: [AddressLike, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "withdraw",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "withdrawOtherTokens",
    values: [AddressLike, AddressLike]
  ): string;

  decodeFunctionResult(functionFragment: "ACCURACY", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "MAX_RATE", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "MAX_REWARDS_DURATION",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "MAX_STAKE", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "MIN_REWARDS_DURATION",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "TREASURY_STAKE_AMOUNT",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "balanceOf", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "claim", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "cumulativeDistributedReward",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "cumulativeRewardPaid",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "currentPeriodUnusedRewardsSum",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "currentRewardPaid",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "disableErrorGuard",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "earned", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "errorGuardDisabled",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "errorGuardPullTokens",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "errorGuardRewardToken",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "errorGuardStakingToken",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "finish", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "finished", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "firstRewardPeriodStart",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getHoldersLength",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getHoldersSlice",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getPotentialAPR",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getTotalRewards",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getUnusedRewards",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getUserInactiveStakesLength",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getUserInactiveStakesSlice",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getUserStakeIdsLength",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "getUserStakesSlice",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "globalId", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "hasStakeId", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "init", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "lastTimeRewardApplicable",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "lastUpdateTime",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "notifyRewardAmount",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "notifyRewardAmountPrevious",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "numOfActiveStakes",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "owner", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "paused", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "periodFinish",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "periodStart",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "renounceOwnership",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "rewardPerToken",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "rewardPerTokenStored",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "rewardRate", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "rewardToken",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "rewardsDuration",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "rewardsRemaining",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "setPaused", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "setRewardsDuration",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "stake", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "stakes", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "stakingToken",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "totalSupply",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "transferOwnership",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "unusedRewardsExtracted",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "userBalances",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "userInactiveStakes",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "withdraw", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "withdrawOtherTokens",
    data: BytesLike
  ): Result;
}

export namespace ErrorGuardDisaabledEvent {
  export type InputTuple = [];
  export type OutputTuple = [];
  export interface OutputObject {}
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace ErrorGuardPulledTokensEvent {
  export type InputTuple = [
    token: AddressLike,
    recepient: AddressLike,
    amount: BigNumberish
  ];
  export type OutputTuple = [token: string, recepient: string, amount: bigint];
  export interface OutputObject {
    token: string;
    recepient: string;
    amount: bigint;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace ErrorGuardUpdatedRewardTokenEvent {
  export type InputTuple = [rewardToken: AddressLike];
  export type OutputTuple = [rewardToken: string];
  export interface OutputObject {
    rewardToken: string;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace ErrorGuardUpdatedStakingTokenEvent {
  export type InputTuple = [stakingToken: AddressLike];
  export type OutputTuple = [stakingToken: string];
  export interface OutputObject {
    stakingToken: string;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace FinishedEvent {
  export type InputTuple = [recepient: AddressLike];
  export type OutputTuple = [recepient: string];
  export interface OutputObject {
    recepient: string;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace InitializedEvent {
  export type InputTuple = [version: BigNumberish];
  export type OutputTuple = [version: bigint];
  export interface OutputObject {
    version: bigint;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace OwnershipTransferredEvent {
  export type InputTuple = [previousOwner: AddressLike, newOwner: AddressLike];
  export type OutputTuple = [previousOwner: string, newOwner: string];
  export interface OutputObject {
    previousOwner: string;
    newOwner: string;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace PausedEvent {
  export type InputTuple = [account: AddressLike];
  export type OutputTuple = [account: string];
  export interface OutputObject {
    account: string;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace RewardAddedEvent {
  export type InputTuple = [reward: BigNumberish];
  export type OutputTuple = [reward: bigint];
  export interface OutputObject {
    reward: bigint;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace RewardPaidEvent {
  export type InputTuple = [
    user: AddressLike,
    id: BigNumberish,
    reward: BigNumberish
  ];
  export type OutputTuple = [user: string, id: bigint, reward: bigint];
  export interface OutputObject {
    user: string;
    id: bigint;
    reward: bigint;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace RewardsDurationUpdatedEvent {
  export type InputTuple = [newDuration: BigNumberish];
  export type OutputTuple = [newDuration: bigint];
  export interface OutputObject {
    newDuration: bigint;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace StakedEvent {
  export type InputTuple = [
    user: AddressLike,
    id: BigNumberish,
    amount: BigNumberish,
    totalSupply: BigNumberish
  ];
  export type OutputTuple = [
    user: string,
    id: bigint,
    amount: bigint,
    totalSupply: bigint
  ];
  export interface OutputObject {
    user: string;
    id: bigint;
    amount: bigint;
    totalSupply: bigint;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace UnpausedEvent {
  export type InputTuple = [account: AddressLike];
  export type OutputTuple = [account: string];
  export interface OutputObject {
    account: string;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace WithdrawnEvent {
  export type InputTuple = [
    user: AddressLike,
    id: BigNumberish,
    amount: BigNumberish,
    totalSupply: BigNumberish
  ];
  export type OutputTuple = [
    user: string,
    id: bigint,
    amount: bigint,
    totalSupply: bigint
  ];
  export interface OutputObject {
    user: string;
    id: bigint;
    amount: bigint;
    totalSupply: bigint;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export namespace WithdrawnTokensEvent {
  export type InputTuple = [recepient: AddressLike, amount: BigNumberish];
  export type OutputTuple = [recepient: string, amount: bigint];
  export interface OutputObject {
    recepient: string;
    amount: bigint;
  }
  export type Event = TypedContractEvent<InputTuple, OutputTuple, OutputObject>;
  export type Filter = TypedDeferredTopicFilter<Event>;
  export type Log = TypedEventLog<Event>;
  export type LogDescription = TypedLogDescription<Event>;
}

export interface Staking extends BaseContract {
  connect(runner?: ContractRunner | null): Staking;
  waitForDeployment(): Promise<this>;

  interface: StakingInterface;

  queryFilter<TCEvent extends TypedContractEvent>(
    event: TCEvent,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TypedEventLog<TCEvent>>>;
  queryFilter<TCEvent extends TypedContractEvent>(
    filter: TypedDeferredTopicFilter<TCEvent>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TypedEventLog<TCEvent>>>;

  on<TCEvent extends TypedContractEvent>(
    event: TCEvent,
    listener: TypedListener<TCEvent>
  ): Promise<this>;
  on<TCEvent extends TypedContractEvent>(
    filter: TypedDeferredTopicFilter<TCEvent>,
    listener: TypedListener<TCEvent>
  ): Promise<this>;

  once<TCEvent extends TypedContractEvent>(
    event: TCEvent,
    listener: TypedListener<TCEvent>
  ): Promise<this>;
  once<TCEvent extends TypedContractEvent>(
    filter: TypedDeferredTopicFilter<TCEvent>,
    listener: TypedListener<TCEvent>
  ): Promise<this>;

  listeners<TCEvent extends TypedContractEvent>(
    event: TCEvent
  ): Promise<Array<TypedListener<TCEvent>>>;
  listeners(eventName?: string): Promise<Array<Listener>>;
  removeAllListeners<TCEvent extends TypedContractEvent>(
    event?: TCEvent
  ): Promise<this>;

  ACCURACY: TypedContractMethod<[], [bigint], "view">;

  MAX_RATE: TypedContractMethod<[], [bigint], "view">;

  MAX_REWARDS_DURATION: TypedContractMethod<[], [bigint], "view">;

  MAX_STAKE: TypedContractMethod<[], [bigint], "view">;

  MIN_REWARDS_DURATION: TypedContractMethod<[], [bigint], "view">;

  TREASURY_STAKE_AMOUNT: TypedContractMethod<[], [bigint], "view">;

  balanceOf: TypedContractMethod<[account: AddressLike], [bigint], "view">;

  claim: TypedContractMethod<[id: BigNumberish], [void], "nonpayable">;

  cumulativeDistributedReward: TypedContractMethod<[], [bigint], "view">;

  cumulativeRewardPaid: TypedContractMethod<[], [bigint], "view">;

  currentPeriodUnusedRewardsSum: TypedContractMethod<[], [bigint], "view">;

  currentRewardPaid: TypedContractMethod<[], [bigint], "view">;

  disableErrorGuard: TypedContractMethod<[], [void], "nonpayable">;

  earned: TypedContractMethod<[id: BigNumberish], [bigint], "view">;

  errorGuardDisabled: TypedContractMethod<[], [boolean], "view">;

  errorGuardPullTokens: TypedContractMethod<
    [token: AddressLike, to: AddressLike, amount: BigNumberish],
    [void],
    "nonpayable"
  >;

  errorGuardRewardToken: TypedContractMethod<
    [_rewardToken: AddressLike],
    [void],
    "nonpayable"
  >;

  errorGuardStakingToken: TypedContractMethod<
    [_stakingToken: AddressLike],
    [void],
    "nonpayable"
  >;

  finish: TypedContractMethod<[recepient: AddressLike], [void], "nonpayable">;

  finished: TypedContractMethod<[], [boolean], "view">;

  firstRewardPeriodStart: TypedContractMethod<[], [bigint], "view">;

  getHoldersLength: TypedContractMethod<[], [bigint], "view">;

  getHoldersSlice: TypedContractMethod<
    [startIndex: BigNumberish, length: BigNumberish],
    [string[]],
    "view"
  >;

  getPotentialAPR: TypedContractMethod<[], [bigint], "view">;

  getTotalRewards: TypedContractMethod<[], [bigint], "view">;

  getUnusedRewards: TypedContractMethod<[], [bigint], "view">;

  getUserInactiveStakesLength: TypedContractMethod<
    [user: AddressLike],
    [bigint],
    "view"
  >;

  getUserInactiveStakesSlice: TypedContractMethod<
    [user: AddressLike, startIndex: BigNumberish, length: BigNumberish],
    [Staking.StakeStructOutput[]],
    "view"
  >;

  getUserStakeIdsLength: TypedContractMethod<
    [user: AddressLike],
    [bigint],
    "view"
  >;

  getUserStakesSlice: TypedContractMethod<
    [user: AddressLike, startIndex: BigNumberish, length: BigNumberish],
    [Staking.StakeStructOutput[]],
    "view"
  >;

  globalId: TypedContractMethod<[], [bigint], "view">;

  hasStakeId: TypedContractMethod<
    [user: AddressLike, id: BigNumberish],
    [boolean],
    "view"
  >;

  init: TypedContractMethod<
    [
      stakingToken_: AddressLike,
      rewardToken_: AddressLike,
      owner_: AddressLike
    ],
    [void],
    "nonpayable"
  >;

  lastTimeRewardApplicable: TypedContractMethod<[], [bigint], "view">;

  lastUpdateTime: TypedContractMethod<[], [bigint], "view">;

  notifyRewardAmount: TypedContractMethod<
    [newRewardRate: BigNumberish],
    [void],
    "nonpayable"
  >;

  notifyRewardAmountPrevious: TypedContractMethod<[], [void], "nonpayable">;

  numOfActiveStakes: TypedContractMethod<[], [bigint], "view">;

  owner: TypedContractMethod<[], [string], "view">;

  paused: TypedContractMethod<[], [boolean], "view">;

  periodFinish: TypedContractMethod<[], [bigint], "view">;

  periodStart: TypedContractMethod<[], [bigint], "view">;

  renounceOwnership: TypedContractMethod<[], [void], "nonpayable">;

  rewardPerToken: TypedContractMethod<[], [bigint], "view">;

  rewardPerTokenStored: TypedContractMethod<[], [bigint], "view">;

  rewardRate: TypedContractMethod<[], [bigint], "view">;

  rewardToken: TypedContractMethod<[], [string], "view">;

  rewardsDuration: TypedContractMethod<[], [bigint], "view">;

  rewardsRemaining: TypedContractMethod<[], [bigint], "view">;

  setPaused: TypedContractMethod<[state: boolean], [void], "nonpayable">;

  setRewardsDuration: TypedContractMethod<
    [rewardsDuration_: BigNumberish],
    [void],
    "nonpayable"
  >;

  stake: TypedContractMethod<[amount: BigNumberish], [void], "nonpayable">;

  stakes: TypedContractMethod<
    [arg0: BigNumberish],
    [
      [
        bigint,
        bigint,
        bigint,
        bigint,
        bigint,
        string,
        bigint,
        bigint,
        bigint
      ] & {
        id: bigint;
        amount: bigint;
        earned: bigint;
        claimed: bigint;
        userRewardPerTokenPaid: bigint;
        owner: string;
        timestamp: bigint;
        unstakedAtBlockNumber: bigint;
        unstakedAtBlockTimestamp: bigint;
      }
    ],
    "view"
  >;

  stakingToken: TypedContractMethod<[], [string], "view">;

  totalSupply: TypedContractMethod<[], [bigint], "view">;

  transferOwnership: TypedContractMethod<
    [newOwner: AddressLike],
    [void],
    "nonpayable"
  >;

  unusedRewardsExtracted: TypedContractMethod<[], [bigint], "view">;

  userBalances: TypedContractMethod<[arg0: AddressLike], [bigint], "view">;

  userInactiveStakes: TypedContractMethod<
    [arg0: AddressLike, arg1: BigNumberish],
    [bigint],
    "view"
  >;

  withdraw: TypedContractMethod<[id: BigNumberish], [void], "nonpayable">;

  withdrawOtherTokens: TypedContractMethod<
    [token: AddressLike, recepient: AddressLike],
    [void],
    "nonpayable"
  >;

  getFunction<T extends ContractMethod = ContractMethod>(
    key: string | FunctionFragment
  ): T;

  getFunction(
    nameOrSignature: "ACCURACY"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "MAX_RATE"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "MAX_REWARDS_DURATION"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "MAX_STAKE"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "MIN_REWARDS_DURATION"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "TREASURY_STAKE_AMOUNT"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "balanceOf"
  ): TypedContractMethod<[account: AddressLike], [bigint], "view">;
  getFunction(
    nameOrSignature: "claim"
  ): TypedContractMethod<[id: BigNumberish], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "cumulativeDistributedReward"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "cumulativeRewardPaid"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "currentPeriodUnusedRewardsSum"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "currentRewardPaid"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "disableErrorGuard"
  ): TypedContractMethod<[], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "earned"
  ): TypedContractMethod<[id: BigNumberish], [bigint], "view">;
  getFunction(
    nameOrSignature: "errorGuardDisabled"
  ): TypedContractMethod<[], [boolean], "view">;
  getFunction(
    nameOrSignature: "errorGuardPullTokens"
  ): TypedContractMethod<
    [token: AddressLike, to: AddressLike, amount: BigNumberish],
    [void],
    "nonpayable"
  >;
  getFunction(
    nameOrSignature: "errorGuardRewardToken"
  ): TypedContractMethod<[_rewardToken: AddressLike], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "errorGuardStakingToken"
  ): TypedContractMethod<[_stakingToken: AddressLike], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "finish"
  ): TypedContractMethod<[recepient: AddressLike], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "finished"
  ): TypedContractMethod<[], [boolean], "view">;
  getFunction(
    nameOrSignature: "firstRewardPeriodStart"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "getHoldersLength"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "getHoldersSlice"
  ): TypedContractMethod<
    [startIndex: BigNumberish, length: BigNumberish],
    [string[]],
    "view"
  >;
  getFunction(
    nameOrSignature: "getPotentialAPR"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "getTotalRewards"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "getUnusedRewards"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "getUserInactiveStakesLength"
  ): TypedContractMethod<[user: AddressLike], [bigint], "view">;
  getFunction(
    nameOrSignature: "getUserInactiveStakesSlice"
  ): TypedContractMethod<
    [user: AddressLike, startIndex: BigNumberish, length: BigNumberish],
    [Staking.StakeStructOutput[]],
    "view"
  >;
  getFunction(
    nameOrSignature: "getUserStakeIdsLength"
  ): TypedContractMethod<[user: AddressLike], [bigint], "view">;
  getFunction(
    nameOrSignature: "getUserStakesSlice"
  ): TypedContractMethod<
    [user: AddressLike, startIndex: BigNumberish, length: BigNumberish],
    [Staking.StakeStructOutput[]],
    "view"
  >;
  getFunction(
    nameOrSignature: "globalId"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "hasStakeId"
  ): TypedContractMethod<
    [user: AddressLike, id: BigNumberish],
    [boolean],
    "view"
  >;
  getFunction(
    nameOrSignature: "init"
  ): TypedContractMethod<
    [
      stakingToken_: AddressLike,
      rewardToken_: AddressLike,
      owner_: AddressLike
    ],
    [void],
    "nonpayable"
  >;
  getFunction(
    nameOrSignature: "lastTimeRewardApplicable"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "lastUpdateTime"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "notifyRewardAmount"
  ): TypedContractMethod<[newRewardRate: BigNumberish], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "notifyRewardAmountPrevious"
  ): TypedContractMethod<[], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "numOfActiveStakes"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "owner"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "paused"
  ): TypedContractMethod<[], [boolean], "view">;
  getFunction(
    nameOrSignature: "periodFinish"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "periodStart"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "renounceOwnership"
  ): TypedContractMethod<[], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "rewardPerToken"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "rewardPerTokenStored"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "rewardRate"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "rewardToken"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "rewardsDuration"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "rewardsRemaining"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "setPaused"
  ): TypedContractMethod<[state: boolean], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "setRewardsDuration"
  ): TypedContractMethod<
    [rewardsDuration_: BigNumberish],
    [void],
    "nonpayable"
  >;
  getFunction(
    nameOrSignature: "stake"
  ): TypedContractMethod<[amount: BigNumberish], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "stakes"
  ): TypedContractMethod<
    [arg0: BigNumberish],
    [
      [
        bigint,
        bigint,
        bigint,
        bigint,
        bigint,
        string,
        bigint,
        bigint,
        bigint
      ] & {
        id: bigint;
        amount: bigint;
        earned: bigint;
        claimed: bigint;
        userRewardPerTokenPaid: bigint;
        owner: string;
        timestamp: bigint;
        unstakedAtBlockNumber: bigint;
        unstakedAtBlockTimestamp: bigint;
      }
    ],
    "view"
  >;
  getFunction(
    nameOrSignature: "stakingToken"
  ): TypedContractMethod<[], [string], "view">;
  getFunction(
    nameOrSignature: "totalSupply"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "transferOwnership"
  ): TypedContractMethod<[newOwner: AddressLike], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "unusedRewardsExtracted"
  ): TypedContractMethod<[], [bigint], "view">;
  getFunction(
    nameOrSignature: "userBalances"
  ): TypedContractMethod<[arg0: AddressLike], [bigint], "view">;
  getFunction(
    nameOrSignature: "userInactiveStakes"
  ): TypedContractMethod<
    [arg0: AddressLike, arg1: BigNumberish],
    [bigint],
    "view"
  >;
  getFunction(
    nameOrSignature: "withdraw"
  ): TypedContractMethod<[id: BigNumberish], [void], "nonpayable">;
  getFunction(
    nameOrSignature: "withdrawOtherTokens"
  ): TypedContractMethod<
    [token: AddressLike, recepient: AddressLike],
    [void],
    "nonpayable"
  >;

  getEvent(
    key: "ErrorGuardDisaabled"
  ): TypedContractEvent<
    ErrorGuardDisaabledEvent.InputTuple,
    ErrorGuardDisaabledEvent.OutputTuple,
    ErrorGuardDisaabledEvent.OutputObject
  >;
  getEvent(
    key: "ErrorGuardPulledTokens"
  ): TypedContractEvent<
    ErrorGuardPulledTokensEvent.InputTuple,
    ErrorGuardPulledTokensEvent.OutputTuple,
    ErrorGuardPulledTokensEvent.OutputObject
  >;
  getEvent(
    key: "ErrorGuardUpdatedRewardToken"
  ): TypedContractEvent<
    ErrorGuardUpdatedRewardTokenEvent.InputTuple,
    ErrorGuardUpdatedRewardTokenEvent.OutputTuple,
    ErrorGuardUpdatedRewardTokenEvent.OutputObject
  >;
  getEvent(
    key: "ErrorGuardUpdatedStakingToken"
  ): TypedContractEvent<
    ErrorGuardUpdatedStakingTokenEvent.InputTuple,
    ErrorGuardUpdatedStakingTokenEvent.OutputTuple,
    ErrorGuardUpdatedStakingTokenEvent.OutputObject
  >;
  getEvent(
    key: "Finished"
  ): TypedContractEvent<
    FinishedEvent.InputTuple,
    FinishedEvent.OutputTuple,
    FinishedEvent.OutputObject
  >;
  getEvent(
    key: "Initialized"
  ): TypedContractEvent<
    InitializedEvent.InputTuple,
    InitializedEvent.OutputTuple,
    InitializedEvent.OutputObject
  >;
  getEvent(
    key: "OwnershipTransferred"
  ): TypedContractEvent<
    OwnershipTransferredEvent.InputTuple,
    OwnershipTransferredEvent.OutputTuple,
    OwnershipTransferredEvent.OutputObject
  >;
  getEvent(
    key: "Paused"
  ): TypedContractEvent<
    PausedEvent.InputTuple,
    PausedEvent.OutputTuple,
    PausedEvent.OutputObject
  >;
  getEvent(
    key: "RewardAdded"
  ): TypedContractEvent<
    RewardAddedEvent.InputTuple,
    RewardAddedEvent.OutputTuple,
    RewardAddedEvent.OutputObject
  >;
  getEvent(
    key: "RewardPaid"
  ): TypedContractEvent<
    RewardPaidEvent.InputTuple,
    RewardPaidEvent.OutputTuple,
    RewardPaidEvent.OutputObject
  >;
  getEvent(
    key: "RewardsDurationUpdated"
  ): TypedContractEvent<
    RewardsDurationUpdatedEvent.InputTuple,
    RewardsDurationUpdatedEvent.OutputTuple,
    RewardsDurationUpdatedEvent.OutputObject
  >;
  getEvent(
    key: "Staked"
  ): TypedContractEvent<
    StakedEvent.InputTuple,
    StakedEvent.OutputTuple,
    StakedEvent.OutputObject
  >;
  getEvent(
    key: "Unpaused"
  ): TypedContractEvent<
    UnpausedEvent.InputTuple,
    UnpausedEvent.OutputTuple,
    UnpausedEvent.OutputObject
  >;
  getEvent(
    key: "Withdrawn"
  ): TypedContractEvent<
    WithdrawnEvent.InputTuple,
    WithdrawnEvent.OutputTuple,
    WithdrawnEvent.OutputObject
  >;
  getEvent(
    key: "WithdrawnTokens"
  ): TypedContractEvent<
    WithdrawnTokensEvent.InputTuple,
    WithdrawnTokensEvent.OutputTuple,
    WithdrawnTokensEvent.OutputObject
  >;

  filters: {
    "ErrorGuardDisaabled()": TypedContractEvent<
      ErrorGuardDisaabledEvent.InputTuple,
      ErrorGuardDisaabledEvent.OutputTuple,
      ErrorGuardDisaabledEvent.OutputObject
    >;
    ErrorGuardDisaabled: TypedContractEvent<
      ErrorGuardDisaabledEvent.InputTuple,
      ErrorGuardDisaabledEvent.OutputTuple,
      ErrorGuardDisaabledEvent.OutputObject
    >;

    "ErrorGuardPulledTokens(address,address,uint256)": TypedContractEvent<
      ErrorGuardPulledTokensEvent.InputTuple,
      ErrorGuardPulledTokensEvent.OutputTuple,
      ErrorGuardPulledTokensEvent.OutputObject
    >;
    ErrorGuardPulledTokens: TypedContractEvent<
      ErrorGuardPulledTokensEvent.InputTuple,
      ErrorGuardPulledTokensEvent.OutputTuple,
      ErrorGuardPulledTokensEvent.OutputObject
    >;

    "ErrorGuardUpdatedRewardToken(address)": TypedContractEvent<
      ErrorGuardUpdatedRewardTokenEvent.InputTuple,
      ErrorGuardUpdatedRewardTokenEvent.OutputTuple,
      ErrorGuardUpdatedRewardTokenEvent.OutputObject
    >;
    ErrorGuardUpdatedRewardToken: TypedContractEvent<
      ErrorGuardUpdatedRewardTokenEvent.InputTuple,
      ErrorGuardUpdatedRewardTokenEvent.OutputTuple,
      ErrorGuardUpdatedRewardTokenEvent.OutputObject
    >;

    "ErrorGuardUpdatedStakingToken(address)": TypedContractEvent<
      ErrorGuardUpdatedStakingTokenEvent.InputTuple,
      ErrorGuardUpdatedStakingTokenEvent.OutputTuple,
      ErrorGuardUpdatedStakingTokenEvent.OutputObject
    >;
    ErrorGuardUpdatedStakingToken: TypedContractEvent<
      ErrorGuardUpdatedStakingTokenEvent.InputTuple,
      ErrorGuardUpdatedStakingTokenEvent.OutputTuple,
      ErrorGuardUpdatedStakingTokenEvent.OutputObject
    >;

    "Finished(address)": TypedContractEvent<
      FinishedEvent.InputTuple,
      FinishedEvent.OutputTuple,
      FinishedEvent.OutputObject
    >;
    Finished: TypedContractEvent<
      FinishedEvent.InputTuple,
      FinishedEvent.OutputTuple,
      FinishedEvent.OutputObject
    >;

    "Initialized(uint8)": TypedContractEvent<
      InitializedEvent.InputTuple,
      InitializedEvent.OutputTuple,
      InitializedEvent.OutputObject
    >;
    Initialized: TypedContractEvent<
      InitializedEvent.InputTuple,
      InitializedEvent.OutputTuple,
      InitializedEvent.OutputObject
    >;

    "OwnershipTransferred(address,address)": TypedContractEvent<
      OwnershipTransferredEvent.InputTuple,
      OwnershipTransferredEvent.OutputTuple,
      OwnershipTransferredEvent.OutputObject
    >;
    OwnershipTransferred: TypedContractEvent<
      OwnershipTransferredEvent.InputTuple,
      OwnershipTransferredEvent.OutputTuple,
      OwnershipTransferredEvent.OutputObject
    >;

    "Paused(address)": TypedContractEvent<
      PausedEvent.InputTuple,
      PausedEvent.OutputTuple,
      PausedEvent.OutputObject
    >;
    Paused: TypedContractEvent<
      PausedEvent.InputTuple,
      PausedEvent.OutputTuple,
      PausedEvent.OutputObject
    >;

    "RewardAdded(uint256)": TypedContractEvent<
      RewardAddedEvent.InputTuple,
      RewardAddedEvent.OutputTuple,
      RewardAddedEvent.OutputObject
    >;
    RewardAdded: TypedContractEvent<
      RewardAddedEvent.InputTuple,
      RewardAddedEvent.OutputTuple,
      RewardAddedEvent.OutputObject
    >;

    "RewardPaid(address,uint256,uint256)": TypedContractEvent<
      RewardPaidEvent.InputTuple,
      RewardPaidEvent.OutputTuple,
      RewardPaidEvent.OutputObject
    >;
    RewardPaid: TypedContractEvent<
      RewardPaidEvent.InputTuple,
      RewardPaidEvent.OutputTuple,
      RewardPaidEvent.OutputObject
    >;

    "RewardsDurationUpdated(uint256)": TypedContractEvent<
      RewardsDurationUpdatedEvent.InputTuple,
      RewardsDurationUpdatedEvent.OutputTuple,
      RewardsDurationUpdatedEvent.OutputObject
    >;
    RewardsDurationUpdated: TypedContractEvent<
      RewardsDurationUpdatedEvent.InputTuple,
      RewardsDurationUpdatedEvent.OutputTuple,
      RewardsDurationUpdatedEvent.OutputObject
    >;

    "Staked(address,uint256,uint256,uint256)": TypedContractEvent<
      StakedEvent.InputTuple,
      StakedEvent.OutputTuple,
      StakedEvent.OutputObject
    >;
    Staked: TypedContractEvent<
      StakedEvent.InputTuple,
      StakedEvent.OutputTuple,
      StakedEvent.OutputObject
    >;

    "Unpaused(address)": TypedContractEvent<
      UnpausedEvent.InputTuple,
      UnpausedEvent.OutputTuple,
      UnpausedEvent.OutputObject
    >;
    Unpaused: TypedContractEvent<
      UnpausedEvent.InputTuple,
      UnpausedEvent.OutputTuple,
      UnpausedEvent.OutputObject
    >;

    "Withdrawn(address,uint256,uint256,uint256)": TypedContractEvent<
      WithdrawnEvent.InputTuple,
      WithdrawnEvent.OutputTuple,
      WithdrawnEvent.OutputObject
    >;
    Withdrawn: TypedContractEvent<
      WithdrawnEvent.InputTuple,
      WithdrawnEvent.OutputTuple,
      WithdrawnEvent.OutputObject
    >;

    "WithdrawnTokens(address,uint256)": TypedContractEvent<
      WithdrawnTokensEvent.InputTuple,
      WithdrawnTokensEvent.OutputTuple,
      WithdrawnTokensEvent.OutputObject
    >;
    WithdrawnTokens: TypedContractEvent<
      WithdrawnTokensEvent.InputTuple,
      WithdrawnTokensEvent.OutputTuple,
      WithdrawnTokensEvent.OutputObject
    >;
  };
}
